function [X,Resnorm] = cg_store(A,b,x0,toler,maxit);
% solves a system Ax=b
% by cg method
%%%%%%%%%%%%%%%%%%%%%%%

x=x0;
r0=b-A*x0; % initial residual
p = r0;


tolb = norm(b)*toler;


dim = length(x0);
X = zeros(dim,maxit+1);
X(:,1) = x0;

Resnorm = zeros(maxit+1,1);
Resnorm(1) = norm(r0);


for i=1:maxit
  z = A*p;
  nu = (r0'*r0)/(p'*z);
  
  x = x + nu*p;
  
  r = r0 - nu*z;
  
  r2 = r'*r;
  
  X(:,i+1) = x;
  Resnorm(i+1) = sqrt(r2); % store the norm
  
  if Resnorm(i)<tolb
    X(:,[i+1:maxit+1]) = repmat(x,[1 maxit-i+1]);
    Resnorm(i+1:maxit+1) = norm(b-A*x);
    break; % exit the loop
  end
  
  mu = r2/(r0'*r0);
  
  % reinitialise
  p = r + mu*p;
  r0=r;
    
end
  
  
if i==maxit
  warning('CG: maximal number of  iterations reached');
end

disp(['Finished after ',num2str(i),' iterations']);

return
figure(200)
plot(normR,'r*-');
title('decay of residuum for cg')